<?php
	require 'databaseClass.php';
	require 'shopify.php';

	if (isset($_GET['code'])) { // if the code param has been sent to this page... we are in Step 2
        // Step 2: do a form POST to get the access token
        $shopifyClient = new ShopifyClient($_GET['shop'], "", SHOPIFY_API_KEY, SHOPIFY_SECRET);

        // Now, request the token and store it in your session.
        $token = $shopifyClient->getAccessToken($_GET['code']);
        
        if ($token != '')
		    
           // $_SESSION['shop'] = $_GET['shop'];

            // Check if shop exists
            $database->query("SELECT * FROM shops WHERE shop = :store_url");
			$database->bind(':store_url', $_GET['shop']);
            $results = $database->resultset();

            $shopifyClient = new ShopifyClient($_GET['shop'], $token, SHOPIFY_API_KEY, SHOPIFY_SECRET);
            
            $storeInfo = $shopifyClient->call('GET', '/admin/api/'.API_VERSION.'/shop.json');
           
            if (count($results) == 0) {

                $findwebhook = $shopifyClient->call('GET', '/admin/webhooks.json',array());
                $webhookdata = '{}';
                if(searchForId('app/uninstalled',$findwebhook) == '' && searchForId('app/uninstalled',$findwebhook) == null){
                        $url = "https://orderapp.11za.com/appuninstall";
                    	$webhook_props = array (
                    	"webhook" => array (
                    		"topic" => "app/uninstalled",
                    		"address" => $url,
                    		"format" => "json"
                    	));
                        $submit[0] = $shopifyClient->call('POST', '/admin/webhooks.json', $webhook_props);
                        
                        $urloc = "https://orderapp.11za.com/orderwebhook?ordertype=create";
                    	$webhook_propsoc = array (
                    	"webhook" => array (
                    		"topic" => "orders/create",
                    		"address" => $urloc,
                    		"format" => "json"
                    	));
                        $submit[1] = $shopifyClient->call('POST', '/admin/webhooks.json', $webhook_propsoc);
                        
                        $urlou = "https://orderapp.11za.com/orderwebhook?ordertype=updated";
                    	$webhook_propsou = array (
                    	"webhook" => array (
                    		"topic" => "orders/updated",
                    		"address" => $urlou,
                    		"format" => "json"
                    	));
                        $submit[2] = $shopifyClient->call('POST', '/admin/webhooks.json', $webhook_propsou);
                        
                        $urlocn = "https://orderapp.11za.com/orderwebhook?ordertype=cancelled";
                    	$webhook_propscn = array (
                    	"webhook" => array (
                    		"topic" => "orders/cancelled",
                    		"address" => $urlocn,
                    		"format" => "json"
                    	));
                        $submit[3] = $shopifyClient->call('POST', '/admin/webhooks.json', $webhook_propscn);
        
                        $webhookdata = json_encode($submit);
                }else{
                   $webhookdata = json_encode($findwebhook); 
                }

                $moneyformat = str_replace("{{amount}}","",$storeInfo['money_format']);
                // Create new
                
                $database->query("INSERT INTO `shops`(`id`,`shop`,`code`,`accesstoken`,`status`,`phone`,`country_code`,`country_name`,`accessscope`,`domain`,`email`,`customer_email`,`currency`,`timezone`,`appstatus`,`webhook`,`created_at`) VALUES ('',:shop,:code,:accesstoken,:status,:phone,:country_code,:country_name,:accessscope,:domain,:email,:customer_email,:currency,:timezone,:appstatus,:webhook,:created_at)");
                $database->bind(':shop', $_GET['shop']);
                $database->bind(':code', $_GET['code']);
                $database->bind(':accesstoken', $token);
                $database->bind(':status', 'Active');
                $database->bind(':phone', $storeInfo['phone']);
                $database->bind(':country_code', $storeInfo['country_code']);
                $database->bind(':country_name', $storeInfo['country_name']);
                $database->bind(':accessscope', SHOPIFY_SCOPE);
                $database->bind(':domain', $storeInfo['domain']);
                $database->bind(':email', $storeInfo['email']);
                $database->bind(':customer_email', $storeInfo['customer_email']);
                $database->bind(':currency', $storeInfo['currency']);
                $database->bind(':timezone', $storeInfo['iana_timezone']);
                $database->bind(':appstatus', 'installed');
                $database->bind(':webhook', $webhookdata);
                $database->bind(':created_at', time());
                $rows = $database->execute();
                
                
                header("Location: https://orderapp.11za.com/dashboard?shopname=".$_GET['shop']);
                exit();
            } else {
                // Update
                if($results[0]["accesstoken"] != $token){

                    $url = "https://orderapp.11za.com/appuninstall";
                	$webhook_props = array (
                	"webhook" => array (
                		"topic" => "app/uninstalled",
                		"address" => $url,
                		"format" => "json"
                	));
                    $submit = $shopifyClient->call('POST', '/admin/webhooks.json', $webhook_props);
                    
                    $webhookdata = json_encode($submit);
                    $database->query("UPDATE `shops` SET `accesstoken` = :accesstoken ,`domain` = :domain ,`email` = :email ,`customer_email` = :customer_email ,`appstatus` = :appstatus ,`phone` = :phone ,`country_code` = :country_code ,`country_name` = :country_name ,`status` = :status ,`webhook` = :webhook WHERE `id` = :id ");
                    $database->bind(':id', $results[0]["id"]);
                    $database->bind(':accesstoken', $token);
                    $database->bind(':domain', $storeInfo['domain']);
                    $database->bind(':email', $storeInfo['email']);
                    $database->bind(':customer_email', $storeInfo['customer_email']);
                    $database->bind(':appstatus', 'installed');
                    $database->bind(':phone', $storeInfo['phone']);
                    $database->bind(':country_code', $storeInfo['country_code']);
                    $database->bind(':country_name', $storeInfo['country_name']);
                    $database->bind(':status', 'Active');
                    $database->bind(':webhook', $webhookdata);
    
                    $database->execute();
                    header("Location: https://orderapp.11za.com/dashboard?shopname=".$_GET['shop']);
                    // header("Location: dashboard?shopname=".$results[0]["shop"]);
                    exit();
                    
                }else{
                    if($results[0]["appstatus"] == 'uninstalled'){

                        $database->query("UPDATE `shops` SET `appstatus` = :appstatus ,`status` = :status WHERE `id` = :id ");
                        $database->bind(':id', $results[0]["id"]);
                        $database->bind(':appstatus', 'installed');
                        $database->bind(':status', 'Active');
                        $database->execute();
                        // header("Location: dashboard?shopname=".$results[0]["shop"]);
                        header("Location: https://orderapp.11za.com/dashboard?shopname=".$results[0]["shop"]);
                        exit();
                    
                    }else{

                        // header("Location: dashboard?shopname=".$results[0]["shop"]);
                        header("Location: https://orderapp.11za.com/dashboard?shopname=".$results[0]["shop"]);
                        exit();
                    }
                }
                     
            }
    }
    
    
function searchForId($id, $array) {
   foreach ($array as $key => $val) {
       if ($val['topic'] === $id) {
           return $key;
       }
   }
   return null;
}

?>